'use strict';var defineProperty=require('@babel/runtime/helpers/esm/defineProperty'),clsx=require('clsx'),twind=require('twind');function _interopDefaultLegacy(e){return e&&typeof e==='object'&&'default'in e?e:{'default':e}}var defineProperty__default=/*#__PURE__*/_interopDefaultLegacy(defineProperty);var clsx__default=/*#__PURE__*/_interopDefaultLegacy(clsx);function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    if (enumerableOnly) symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    });
    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        defineProperty__default['default'](target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}const variant = (args) => {
    return {
        variant: {
            type: args && args.type ? args.type : [String],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false
        }
    };
};
const classAppend = (args) => {
    return {
        classAppend: {
            type: args && args.type ? args.type : [String, Array],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false
        }
    };
};
const classRemove = (args) => {
    return {
        classRemove: {
            type: args && args.type ? args.type : [String, Array],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false
        }
    };
};
const as = (args) => {
    return {
        as: {
            type: args && args.type ? args.type : [String, Object],
            default: args && args.default ? args.default : "div",
            required: args && args.required ? args.required : false
        }
    };
};
const status = (args) => {
    return {
        status: {
            type: args && args.type ? args.type : [String, Boolean],
            default: args && args.default ? args.default : false,
            required: args && args.required ? args.required : false,
            validator: args && args.validator ? args.validator : () => true
        }
    };
};
const size = (args) => {
    return {
        size: {
            type: args && args.type ? args.type : [String],
            default: args && args.default ? args.default : "",
            required: args && args.required ? args.required : false,
            validator: args && args.validator ? args.validator : () => true
        }
    };
};// Classy
class Classy {
    constructor(starter) {
        if (starter) {
            this.value = Array.isArray(starter) ? starter : this.toArray(starter);
        }
        else {
            this.value = [];
        }
    }
    // Chains
    append(classes) {
        this.value = clsx__default['default'](this.value, classes);
        return this;
    }
    remove(classes) {
        const classArray = typeof classes === "string" ? classes.split(" ") : classes;
        this.value = this.toArray(this.value).filter((className) => !classArray.includes(className));
        return this;
    }
    twind(enable = true) {
        if (enable) {
            this.value = twind.tw `${this.value}`;
        }
        return this;
    }
    val(type) {
        if (type === "array") {
            return this.toArray(this.value);
        }
        return clsx__default['default'](this.value);
    }
    // Helpers
    toArray(classes) {
        return typeof classes === "string" ? classes.split(" ") : classes;
    }
    toString(classes) {
        return Array.isArray(classes) ? classes.join(" ") : classes;
    }
}const registerComponent = (instance, component) => {
    if (component) {
        instance.component(component.name || "", component);
    }
};exports.C=Classy;exports._=_objectSpread2;exports.a=classRemove;exports.b=status;exports.c=classAppend;exports.d=as;exports.r=registerComponent;exports.s=size;exports.v=variant;