import './export-54398709.js';
import '@babel/runtime/helpers/esm/defineProperty';
import { _ as _objectSpread2, d as as, c as classAppend, a as classRemove, v as variant, b as status, C as Classy, r as registerComponent } from './index-fad2593b.js';
import { defineComponent, inject, computed, resolveComponent, openBlock, createBlock, withCtx, renderSlot, h, resolveDynamicComponent, Transition, createVNode, createCommentVNode, provide } from 'vue';
import 'clsx';
import { tw } from 'twind';
import merge from 'lodash.merge';
import './es.array.includes-a47ed4b6.js';
import { MenuButton, MenuItem, MenuItems, Menu } from '@headlessui/vue';

var script = defineComponent({
  name: "DropdownButton",
  components: {
    HMenuButton: MenuButton
  },
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "DEFAULT"
  })), status()), as({
    default: "button"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var twindEnable = inject("twindEnable", true);
    var status = props.status && props.status !== false ? props.status : inject("status", false);
    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "DEFAULT");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].DropdownButton) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var statusClasses = status && theme[status] ? theme[status].DropdownButton : false;
    var classes = computed(function () {
      return new Classy().append(statusClasses !== null && statusClasses !== void 0 ? statusClasses : theme[variantClasses]).append(props.classAppend).remove(props.classRemove).twind(twindEnable).val();
    });
    return {
      classes: classes,
      status: status
    };
  }
});

function render(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HMenuButton = resolveComponent("HMenuButton");

  return openBlock(), createBlock(_component_HMenuButton, {
    as: _ctx.status === 'disabled' ? 'button' : _ctx.as,
    class: _ctx.classes,
    disabled: _ctx.status === 'disabled'
  }, {
    default: withCtx(function (_ref) {
      var open = _ref.open;
      return [renderSlot(_ctx.$slots, "default", {
        open: open
      })];
    }),
    _: 3
  }, 8, ["as", "class", "disabled"]);
}

script.render = render;

var HtmlElement = defineComponent({
  name: "HtmlElement",
  props: {
    el: {
      type: [Object, String],
      default: "div"
    }
  },
  setup: function setup(props, _ref) {
    var slots = _ref.slots;
    return function () {
      var _slots$default;

      return h(props.el, {}, slots === null || slots === void 0 ? void 0 : (_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots));
    };
  }
});
var script$1 = defineComponent({
  name: "DropdownItem",
  components: {
    HMenuItem: MenuItem,
    HtmlElement: HtmlElement
  },
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend({
    type: Object,
    default: {
      BASE: "",
      active: "",
      inactive: ""
    }
  })), classRemove({
    type: Object,
    default: {
      BASE: "",
      active: "",
      inactive: ""
    }
  })), variant({
    default: "DEFAULT"
  })), as({
    default: "button"
  })), status({
    default: false,
    validator: function validator(v) {
      return !v || ["disabled"].includes(v);
    }
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var twindEnable = inject("twindEnable", true);
    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "DEFAULT");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].DropdownItem) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : console.error("Could not find variant classes.");
    var statusClasses = props.status && theme[props.status] ? theme[props.status].DropdownItem : false;
    var classes = computed(function () {
      var _statusClasses$BASE, _props$classAppend, _props$classRemove, _props$classAppend2, _props$classRemove2, _props$classAppend3, _props$classRemove3;

      return {
        BASE: new Classy().append((_statusClasses$BASE = statusClasses.BASE) !== null && _statusClasses$BASE !== void 0 ? _statusClasses$BASE : variantClasses === null || variantClasses === void 0 ? void 0 : variantClasses.BASE).append((_props$classAppend = props.classAppend) === null || _props$classAppend === void 0 ? void 0 : _props$classAppend.BASE).remove((_props$classRemove = props.classRemove) === null || _props$classRemove === void 0 ? void 0 : _props$classRemove.BASE).twind(twindEnable).val(),
        active: new Classy().append(variantClasses === null || variantClasses === void 0 ? void 0 : variantClasses.active).append((_props$classAppend2 = props.classAppend) === null || _props$classAppend2 === void 0 ? void 0 : _props$classAppend2.active).remove((_props$classRemove2 = props.classRemove) === null || _props$classRemove2 === void 0 ? void 0 : _props$classRemove2.active).twind(twindEnable).val(),
        inactive: new Classy().append(variantClasses === null || variantClasses === void 0 ? void 0 : variantClasses.inactive).append((_props$classAppend3 = props.classAppend) === null || _props$classAppend3 === void 0 ? void 0 : _props$classAppend3.inactive).remove((_props$classRemove3 = props.classRemove) === null || _props$classRemove3 === void 0 ? void 0 : _props$classRemove3.inactive).twind(twindEnable).val()
      };
    });
    return {
      classes: classes
    };
  }
});

function render$1(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HtmlElement = resolveComponent("HtmlElement");

  var _component_HMenuItem = resolveComponent("HMenuItem");

  return openBlock(), createBlock(_component_HMenuItem, {
    as: "template",
    disabled: _ctx.status === 'disabled'
  }, {
    default: withCtx(function (_ref) {
      var active = _ref.active;
      return [typeof _ctx.as === 'string' ? (openBlock(), createBlock(_component_HtmlElement, {
        key: 0,
        el: _ctx.as,
        class: [active ? _ctx.classes.active : _ctx.classes.inactive, _ctx.classes.BASE]
      }, {
        default: withCtx(function () {
          return [renderSlot(_ctx.$slots, "default", {
            active: active
          })];
        }),
        _: 2
      }, 1032, ["el", "class"])) : (openBlock(), createBlock(resolveDynamicComponent(_ctx.as), {
        key: 1
      }, {
        default: withCtx(function () {
          return [renderSlot(_ctx.$slots, "default", {
            active: active
          })];
        }),
        _: 2
      }, 1024))];
    }),
    _: 1
  }, 8, ["disabled"]);
}

script$1.render = render$1;

var script$2 = defineComponent({
  name: "DropdownItems",
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "DEFAULT"
  })), status()),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var status = inject("status");
    var align = inject("align", "left");
    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "DEFAULT");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].DropdownItems) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return {
        items: new Classy().append(variantClasses).append(theme.align[align]).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val(),
        transition: {
          enterActiveClass: new Classy(theme.transition.DEFAULT.enterActiveClass).twind().val(),
          enterFromClass: new Classy(theme.transition.DEFAULT.enterFromClass).twind().val(),
          enterToClass: new Classy(theme.transition.DEFAULT.enterToClass).twind().val(),
          leaveActiveClass: new Classy(theme.transition.DEFAULT.leaveActiveClass).twind().val(),
          leaveFromClass: new Classy(theme.transition.DEFAULT.leaveFromClass).twind().val(),
          leaveToClass: new Classy(theme.transition.DEFAULT.leaveToClass).twind().val()
        }
      };
    });
    return {
      classes: classes,
      tw: tw,
      status: status
    };
  },
  components: {
    HMenuItems: MenuItems
  }
});

function render$2(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HMenuItems = resolveComponent("HMenuItems");

  return _ctx.status !== 'disabled' ? (openBlock(), createBlock(Transition, {
    key: 0,
    "enter-active-class": _ctx.classes.transition.enterActiveClass,
    "enter-from-class": _ctx.classes.transition.enterFromClass,
    "enter-to-class": _ctx.classes.transition.enterToClass,
    "leave-active-class": _ctx.classes.transition.leaveActiveClass,
    "leave-from-class": _ctx.classes.transition.leaveFromClass,
    "leave-to-class": _ctx.classes.transition.leaveToClass
  }, {
    default: withCtx(function () {
      return [createVNode(_component_HMenuItems, {
        class: _ctx.classes.items
      }, {
        default: withCtx(function () {
          return [renderSlot(_ctx.$slots, "default")];
        }),
        _: 3
      }, 8, ["class"])];
    }),
    _: 1
  }, 8, ["enter-active-class", "enter-from-class", "enter-to-class", "leave-active-class", "leave-from-class", "leave-to-class"])) : createCommentVNode("", true);
}

script$2.render = render$2;

const dropDownBase = {
    Dropdown: "relative inline-block text-left",
    DropdownButton: "",
    DropdownItems: "absolute z-10 w-56 mt-2 overflow-hidden bg-white border border-gray-200 divide-y divide-gray-100 rounded-md shadow-lg outline-none",
};
// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
const Theme = (userTheme) => {
    return merge({
        DEFAULT: {
            ...dropDownBase,
            DropdownItem: {
                BASE: "flex justify-between w-full px-4 py-2 text-sm leading-5 text-left",
                active: "bg-gray-100 text-gray-900",
                inactive: "text-gray-700",
            },
        },
        danger: {
            DropdownItem: {
                BASE: "flex justify-between w-full px-4 py-2 text-sm leading-5 text-left",
                active: "bg-red-100 text-red-900",
                inactive: "text-gray-700",
            }
        },
        success: {
            DropdownItem: {
                BASE: "flex justify-between w-full px-4 py-2 text-sm leading-5 text-left",
                active: "bg-green-100 text-green-900",
                inactive: "text-gray-700",
            }
        },
        disabled: {
            DropdownButton: "cursor-not-allowed",
            DropdownItem: {
                BASE: "text-gray-300 flex justify-between w-full px-4 py-2 text-sm leading-5 text-left cursor-not-allowed",
                active: "",
                inactive: "",
            }
        },
        align: {
            left: "right-0 origin-top-right",
            right: "left-0 origin-top-left"
        },
        transition: {
            DEFAULT: {
                enterActiveClass: "transition duration-100 ease-out",
                enterFromClass: "transform scale-95 opacity-0",
                enterToClass: "transform scale-100 opacity-100",
                leaveActiveClass: "transition duration-75 ease-out",
                leaveFromClass: "transform scale-100 opacity-100",
                leaveToClass: "transform scale-95 opacity-0",
            }
        }
    }, userTheme ? userTheme.ZDropdown : null);
};

var Dropdown = defineComponent({
  name: "Dropdown",
  components: {
    HMenu: Menu
  },
  props: _objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "DEFAULT"
  })), status()), as({
    default: "template"
  })), {}, {
    align: {
      type: String,
      default: "left",
      validator: function validator(v) {
        return ["right", "left"].includes(v);
      }
    }
  }),
  setup: function setup(props) {
    var _computed = computed(function () {
      return Theme(inject("userTheme", {}));
    }),
        theme = _computed.value;

    var classes = computed(function () {
      return new Classy().append(theme[props.variant].Dropdown).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    provide("theme", theme);
    provide("variant", props.variant);
    provide("align", props.align);
    provide("status", props.status);
    return {
      classes: classes
    };
  }
});

function render$3(_ctx, _cache, $props, $setup, $data, $options) {
  var _component_HMenu = resolveComponent("HMenu");

  return openBlock(), createBlock("div", {
    class: _ctx.classes
  }, [createVNode(_component_HMenu, {
    as: _ctx.as
  }, {
    default: withCtx(function (_ref) {
      var open = _ref.open;
      return [renderSlot(_ctx.$slots, "default", {
        open: open,
        variant: _ctx.variant
      })];
    }),
    _: 3
  }, 8, ["as"])], 2);
}

Dropdown.render = render$3;

const DropdownPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, Dropdown);
    },
};
const DropdownButtonPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, script);
    },
};
const DropdownItemsPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, script$2);
    },
};
const DropdownItemPlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, script$1);
    },
};

export { Dropdown, script as DropdownButton, DropdownButtonPlugin, script$1 as DropdownItem, DropdownItemPlugin, script$2 as DropdownItems, DropdownItemsPlugin, DropdownPlugin };
