import '@babel/runtime/helpers/esm/defineProperty';
import { _ as _objectSpread2, a as classRemove, c as classAppend, C as Classy, v as variant, r as registerComponent } from './index-fad2593b.js';
import { defineComponent, computed, inject, openBlock, createBlock, createVNode, renderSlot, provide } from 'vue';
import 'clsx';
import { tw } from 'twind';
import merge from 'lodash.merge';

var script = defineComponent({
  props: _objectSpread2(_objectSpread2({}, classAppend({
    type: Object,
    default: {}
  })), classRemove({
    type: Object,
    default: {}
  })),
  setup: function setup(props) {
    var classes = computed(function () {
      var _props$classAppend$ou, _props$classAppend, _props$classRemove$ou, _props$classRemove, _props$classAppend$in, _props$classAppend2, _props$classRemove$in, _props$classRemove2;

      return {
        outerWrapper: new Classy("-my-2 overflow-x-auto sm:-mx-6 lg:-mx-8").append((_props$classAppend$ou = (_props$classAppend = props.classAppend) === null || _props$classAppend === void 0 ? void 0 : _props$classAppend.outerWrapper) !== null && _props$classAppend$ou !== void 0 ? _props$classAppend$ou : "").remove((_props$classRemove$ou = (_props$classRemove = props.classRemove) === null || _props$classRemove === void 0 ? void 0 : _props$classRemove.outerWrapper) !== null && _props$classRemove$ou !== void 0 ? _props$classRemove$ou : "").twind(inject("twindEnable", true)).val(),
        innerWrapper: new Classy("inline-block min-w-full py-2 align-middle sm:px-6 lg:px-8").append((_props$classAppend$in = (_props$classAppend2 = props.classAppend) === null || _props$classAppend2 === void 0 ? void 0 : _props$classAppend2.innerWrapper) !== null && _props$classAppend$in !== void 0 ? _props$classAppend$in : "").remove((_props$classRemove$in = (_props$classRemove2 = props.classRemove) === null || _props$classRemove2 === void 0 ? void 0 : _props$classRemove2.innerWrapper) !== null && _props$classRemove$in !== void 0 ? _props$classRemove$in : "").twind(inject("twindEnable", true)).val()
      };
    });
    return {
      classes: classes
    };
  }
});

function render(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("div", {
    class: _ctx.classes.outerWrapper
  }, [createVNode("div", {
    class: _ctx.classes.innerWrapper
  }, [renderSlot(_ctx.$slots, "default")], 2)], 2);
}

script.render = render;

var script$1 = defineComponent({
  name: "Thead",
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Thead) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$1(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("thead", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$1.render = render$1;

var script$2 = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Tbody) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$2(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("tbody", null, [renderSlot(_ctx.$slots, "default")]);
}

script$2.render = render$2;

var script$3 = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].tr) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$3(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("tr", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$3.render = render$3;

var script$4 = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Th) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$4(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("th", {
    scope: "col",
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$4.render = render$4;

var script$5 = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _props$variant, _theme$resolvedVarian;

    var theme = inject("theme"); // eslint-disable-line @typescript-eslint/no-explicit-any

    var resolvedVariant = (_props$variant = props.variant) !== null && _props$variant !== void 0 ? _props$variant : inject("variant", "primary");
    var variantClasses = (_theme$resolvedVarian = theme === null || theme === void 0 ? void 0 : theme[resolvedVariant].Td) !== null && _theme$resolvedVarian !== void 0 ? _theme$resolvedVarian : "";
    var classes = computed(function () {
      return new Classy().append(variantClasses).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    return {
      classes: classes
    };
  }
});

function render$5(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("td", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

script$5.render = render$5;

// eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types, @typescript-eslint/no-explicit-any
var Theme = (userTheme) => {
    return merge({
        primary: {
            Table: "min-w-full",
            Thead: "border-b border-gray-200 dark:border-gray-800 bg-gray-100 dark:bg-gray-800",
            Tbody: "",
            Tr: "border-b border-gray-200 dark:border-gray-700 last:border-0",
            Th: "px-6 pt-4 pb-3 text-left text-xs font-medium text-gray-500 dark:text-gray-400 uppercase tracking-wider",
            Td: "px-6 py-4 whitespace-nowrap text-sm text-gray-900 dark:text-gray-100",
        },
    }, userTheme ? userTheme.Table : null);
};

var Table = defineComponent({
  props: _objectSpread2(_objectSpread2(_objectSpread2({}, classAppend()), classRemove()), variant({
    default: "primary"
  })),
  setup: function setup(props) {
    var _computed = computed(function () {
      return Theme(inject("userTheme", {}));
    }),
        theme = _computed.value;

    var classes = computed(function () {
      return new Classy(theme[props.variant].Table).append(props.classAppend).remove(props.classRemove).twind(inject("twindEnable", true)).val();
    });
    provide("theme", theme);
    provide("variant", props.variant);
    return {
      tw: tw,
      classes: classes
    };
  }
});

function render$6(_ctx, _cache, $props, $setup, $data, $options) {
  return openBlock(), createBlock("table", {
    class: _ctx.classes
  }, [renderSlot(_ctx.$slots, "default")], 2);
}

Table.render = render$6;

const TablePlugin = {
    // eslint-disable-next-line @typescript-eslint/explicit-module-boundary-types
    install(vue) {
        registerComponent(vue, Table);
    },
};

export default Table;
export { TablePlugin };
